Core Features

Advanced Features

JavaScript Data GridRow Dragging Customisation

Version 36.2.0

There are some options that can be used to customise the Row Drag experience, so it has a better integration with your application.

Entire Row Dragging Copy Link

When using row dragging it is also possible to reorder rows by clicking and dragging anywhere on the row without the need for a drag handle by enabling the rowDragEntireRow grid option.

The example above demonstrates entire row dragging with Multi-Row Dragging. Note the following:

  • Reordering rows by clicking and dragging anywhere on a row is possible as rowDragEntireRow is enabled.
  • Multiple rows can be selected and dragged as rowDragMultiRow is also enabled with rowSelection.mode = 'multiRow'.
  • Row Drag Managed is being used, but it is not a requirement for Entire Row Dragging.

To enable entire row dragging, set the rowDragEntireRow property to true in the gridOptions as shown below:

const gridOptions = {
    columnDefs: [
        { field: 'country' },
        { field: 'year' },
        { field: 'sport' },
        { field: 'total' }
    ],
    // allows rows to be dragged without the need for drag handles
    rowDragEntireRow: true,

    // other grid options ...
}

Cell Selection is not supported when rowDragEntireRow is enabled.

Custom Row Drag Text Copy Link

When a row drag starts, a "floating" DOM element is created to indicate which row is being dragged. By default, this DOM element will contain the same value as the cell that started the row drag. It's possible to override that text by using the gridOptions.rowDragText callback.

The example above shows dragging with custom text. The following can be noted:

  • When you drag a row of the year 2012, the rowDragText callback will add (London Olympics) to the floating drag element.

To enable custom row drag text, set the rowDragText callback in the gridOptions as shown below:

const gridOptions = {
    columnDefs: [
        {
            field: 'athlete',
            rowDrag: true
        }, {
            field: 'country'
        }
    ],
    rowDragText: (params, dragItemCount) => {
        return (
            dragItemCount > 1
                ? (dragItemCount + ' items')
                : params.defaultTextValue + ' is'
        ) + ' being dragged...';
    },

    // other grid options ...
}
rowDragTextCopy Link
RowDragTextFunc
A callback that should return a string to be displayed by the rowDragComp while dragging a row. If this callback is not set, the current cell value will be used. If the rowDragText callback is set in the ColDef it will take precedence over this, except when rowDragEntireRow=true.

Custom Row Drag Text with Multiple Draggers Copy Link

If the grid has more than one column set with rowDrag=true, the rowDragText callback can be set in the colDef.

The example above shows dragging with custom text and multiple column draggers. The following can be noted:

  • When you drag a row with a year of 2012 by the country row dragger, the rowDragText callback will add (London Olympics) to the floating drag element.

  • When you drag the row by the athlete row dragger, the rowDragText callback in the gridOptions will be overridden by the one in the colDef and will display the number of athletes selected.

To enable custom row drag text per column dragger, set the rowDragText callback in the colDef as shown below:

const gridOptions = {
    columnDefs: [
        {
            field: 'athlete',
            rowDrag: true,
            rowDragText: (params, dragItemCount) => {
                const suffix = dragItemCount == 1 ? 'athlete' : 'athletes';
                return `Dragging ${dragItemCount} ${suffix}`;
            }
        }, {
            field: 'country',
            rowDrag: true,
        }
    ],
    rowDragText: (params, dragItemCount) => {
        return (
            dragItemCount > 1
                ? (dragItemCount + ' items')
                : params.defaultTextValue + ' is'
        ) + ' being dragged...';
    },

    // other grid options ...
}

Row Dragger inside Custom Cell Renderers Copy Link

Due to the complexity of some applications, it could be handy to render the Row Drag Component inside of a Custom Cell Renderer. This can be achieved by using the registerRowDragger method in the ICellRendererParams.

The example above shows a custom cell renderer using the registerRowDragger callback to render the Row Dragger inside itself.

  • When you hover the cells, an arrow will appear, and this arrow can be used to drag the rows.

To register a custom row dragger inside a custom cell renderer, use the registerRowDragger method from the ICellRendererParams as shown below:

// your custom cell renderer init code
const rowDragger = document.createElement('div')
this.eGui.appendChild(rowDragger);

// register it as a row dragger
params.registerRowDragger(rowDragger);

When using registerRowDragger you should not set the property rowDrag=true in the Column Definition. Doing that will cause the cell to have two row draggers.

Full Width Row Dragging Copy Link

It is possible to drag Full Width Rows by registering a Custom Row Dragger.

In the example above, only the full width rows are draggable.

Row Dragger with Custom Start Drag Pixels Copy Link

By default, the drag event only starts after the Row Drag Element has been dragged by 4px, but sometimes it might be useful to start the drag with a different drag threshold. For example, start dragging as soon as the mousedown event happens (dragged by 0px). For that reason, the registerRowDragger takes a second parameter to specify the number of pixels that will start the drag event.

In the example above, the drag event starts as soon as mousedown is fired.

Custom Drag and Drop Image Copy Link

The drag and drop image can be customised via the grid properties dragAndDropImageComponent and dragAndDropImageComponentParams.

Implement this interface to provide a custom drag and drop image component when dragging parts of the grid.

interface IDragAndDropImageComponent {
    // Optional - props for rendering.
    init?(params: IDragAndDropImageParams): void;

    // Mandatory - Return the DOM element of the component, this is what the grid will display while dragging
    getGui(): HTMLElement;

    // Optional - Gets called once by grid after rendering is finished - if your renderer needs to do any cleanup,
    // do it here
    destroy?(): void;

    // Mandatory - Gets called every time the grid needs to update the label of the Drag Image.
    setLabel(label: string): void;

    // Mandatory - Gets called every time the grid needs to update the icon of the Drag Image.
    setIcon(icon: string | null, shake: boolean): void;
}

IDragAndDropImageParams Copy Link

dragSourceCopy Link
DragSource
DragSource
The grid api.
Application context as set on gridOptions.context.

Custom Params Copy Link

On top of the parameters provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the component. For example, you might have parts of the grid that you want to highlight with a different colour.

colDef = {
    dragAndDropImageComponent: MyDragAndDropImageComponent,
    dragAndDropImageComponentParams : {
        accentColour: 'SlateGray'
    }
}

There are some options that can be used to customise the Row Drag experience, so it has a better integration with your application.
Entire Row Dragging Copy Link
When using row dragging it is also possible to reorder rows by clicking and dragging anywhere on the row without the need for a drag handle by enabling the rowDragEntireRow grid option.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowDragManaged]="true"
[rowDragEntireRow]="true"
[rowDragMultiRow]="true"
[rowSelection]="rowSelection"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete" },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
];
defaultColDef: ColDef = {
width: 170,
filter: true,
};
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above demonstrates entire row dragging with Multi-Row Dragging. Note the following:
- Reordering rows by clicking and dragging anywhere on a row is possible as
rowDragEntireRowis enabled. - Multiple rows can be selected and dragged as
rowDragMultiRowis also enabled withrowSelection.mode = 'multiRow'. - Row Drag Managed is being used, but it is not a requirement for Entire Row Dragging.
To enable entire row dragging, set the rowDragEntireRow property to true in the gridOptions as shown below:
<ag-grid-angular
[columnDefs]="columnDefs"
[rowDragEntireRow]="rowDragEntireRow"
/* other grid options ... */ />
this.columnDefs = [
{ field: 'country' },
{ field: 'year' },
{ field: 'sport' },
{ field: 'total' }
];
// allows rows to be dragged without the need for drag handles
this.rowDragEntireRow = true;Cell Selection is not supported when rowDragEntireRow is enabled.
Custom Row Drag Text Copy Link
When a row drag starts, a "floating" DOM element is created to indicate which row is being dragged. By default, this DOM element will contain the same value as the cell that started the row drag. It's possible to override that text by using the gridOptions.rowDragText callback.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IRowDragItem,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowDragTextFunc,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[rowDragText]="rowDragText"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowDragManaged]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
rowDragText: RowDragTextFunc = function (params: IRowDragItem) {
// keep double equals here because data can be a string or number
if (params.rowNode!.data.year == "2012") {
return params.defaultTextValue + " (London Olympics)";
}
return params.defaultTextValue;
};
columnDefs: ColDef[] = [
{ field: "athlete", rowDrag: true },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
];
defaultColDef: ColDef = {
width: 170,
filter: true,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above shows dragging with custom text. The following can be noted:
- When you drag a row of the year 2012, the
rowDragTextcallback will add (London Olympics) to the floating drag element.
To enable custom row drag text, set the rowDragText callback in the gridOptions as shown below:
<ag-grid-angular
[columnDefs]="columnDefs"
[rowDragText]="rowDragText"
/* other grid options ... */ />
this.columnDefs = [
{
field: 'athlete',
rowDrag: true
}, {
field: 'country'
}
];
this.rowDragText = (params, dragItemCount) => {
return (
dragItemCount > 1
? (dragItemCount + ' items')
: params.defaultTextValue + ' is'
) + ' being dragged...';
};A callback that should return a string to be displayed by the rowDragComp while dragging a row.
If this callback is not set, the current cell value will be used.
If the rowDragText callback is set in the ColDef it will take precedence over this, except when
rowDragEntireRow=true. |
Custom Row Drag Text with Multiple Draggers Copy Link
If the grid has more than one column set with rowDrag=true, the rowDragText callback can be set in the colDef.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IRowDragItem,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowDragTextFunc,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
ClientSideRowModelModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowDragManaged]="true"
[rowDragText]="rowDragText"
[rowDragMultiRow]="true"
[rowSelection]="rowSelection"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
field: "athlete",
rowDrag: true,
rowDragText: athleteRowDragTextCallback,
},
{ field: "country", rowDrag: true },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
];
defaultColDef: ColDef = {
width: 170,
filter: true,
};
rowDragText: RowDragTextFunc = rowDragTextCallback;
rowSelection: RowSelectionOptions | "single" | "multiple" = {
mode: "multiRow",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
const athleteRowDragTextCallback = function (
params: IRowDragItem,
dragItemCount: number,
) {
// keep double equals here because data can be a string or number
return `${dragItemCount} athlete(s) selected`;
};
const rowDragTextCallback = function (params: IRowDragItem) {
// keep double equals here because data can be a string or number
if (params.rowNode!.data.year == "2012") {
return params.defaultTextValue + " (London Olympics)";
}
return params.defaultTextValue;
};
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above shows dragging with custom text and multiple column draggers. The following can be noted:
When you drag a row with a year of 2012 by the country row dragger, the
rowDragTextcallback will add (London Olympics) to the floating drag element.When you drag the row by the athlete row dragger, the
rowDragTextcallback in thegridOptionswill be overridden by the one in thecolDefand will display the number of athletes selected.
To enable custom row drag text per column dragger, set the rowDragText callback in the colDef as shown below:
<ag-grid-angular
[columnDefs]="columnDefs"
[rowDragText]="rowDragText"
/* other grid options ... */ />
this.columnDefs = [
{
field: 'athlete',
rowDrag: true,
rowDragText: (params, dragItemCount) => {
const suffix = dragItemCount == 1 ? 'athlete' : 'athletes';
return `Dragging ${dragItemCount} ${suffix}`;
}
}, {
field: 'country',
rowDrag: true,
}
];
this.rowDragText = (params, dragItemCount) => {
return (
dragItemCount > 1
? (dragItemCount + ' items')
: params.defaultTextValue + ' is'
) + ' being dragged...';
}; Row Dragger inside Custom Cell Renderers Copy Link
Due to the complexity of some applications, it could be handy to render the Row Drag Component inside of a Custom Cell Renderer. This can be achieved by using the registerRowDragger method in the ICellRendererParams.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
CellStyleModule,
ClientSideRowModelModule,
]);
import { CustomCellRenderer } from "./custom-cell-renderer.component";
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomCellRenderer],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowDragManaged]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
field: "athlete",
cellClass: "custom-athlete-cell",
cellRenderer: CustomCellRenderer,
},
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
];
defaultColDef: ColDef = {
width: 170,
filter: true,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.ag-ltr .ag-cell.custom-athlete-cell.ag-cell-focus:not(.ag-cell-range-selected):focus-within {
border: 1px solid #ff7b7b;
}
.ag-cell.custom-athlete-cell {
padding-left: 0;
padding-right: 0;
}
.ag-cell.custom-athlete-cell > div {
height: 100%;
}
.my-custom-cell-renderer {
display: flex;
font-size: 0.7rem;
background-color: #4180d6;
color: white;
padding: 0.25rem;
align-items: center;
justify-content: space-between;
box-sizing: border-box;
height: 100%;
}
.my-custom-cell-renderer > * {
line-height: normal;
}
.my-custom-cell-renderer i {
visibility: hidden;
cursor: move;
color: orange;
}
.my-custom-cell-renderer:hover i {
visibility: visible;
}
.my-custom-cell-renderer .athlete-info {
display: flex;
flex-direction: column;
width: 85px;
max-width: 85px;
}
.my-custom-cell-renderer .athlete-info > span {
overflow: hidden;
text-overflow: ellipsis;
}
import type { ElementRef } from '@angular/core';
import { ChangeDetectionStrategy, Component, HostBinding, ViewChild, signal } from '@angular/core';
import type { ICellRendererAngularComp } from 'ag-grid-angular';
import type { ICellRendererParams } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `<div class="athlete-info">
<span>{{ data()?.athlete }}</span>
<span>{{ data()?.country }}</span>
</div>
<span>{{ data()?.year }}</span>
<i class="fas fa-arrows-alt-v" #myref></i>`,
})
export class CustomCellRenderer implements ICellRendererAngularComp {
data = signal(undefined);
private cellRendererParams!: ICellRendererParams;
@ViewChild('myref') myRef!: ElementRef;
@HostBinding('class') class = 'my-custom-cell-renderer';
agInit(params: ICellRendererParams): void {
this.cellRendererParams = params;
this.data.set(params.data);
}
ngAfterViewInit() {
this.cellRendererParams.registerRowDragger(this.myRef.nativeElement);
}
refresh(params: ICellRendererParams): boolean {
return false;
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The example above shows a custom cell renderer using the registerRowDragger callback to render the Row Dragger inside itself.
- When you hover the cells, an arrow will appear, and this arrow can be used to drag the rows.
To register a custom row dragger inside a custom cell renderer, use the registerRowDragger method from the ICellRendererParams as shown below:
// your custom cell renderer code
@ViewChild('myref') myRef;
agInit(params: ICellRendererParams): void {
this.cellRendererParams = params;
}
ngAfterViewInit() {
this.cellRendererParams.registerRowDragger(this.myRef.nativeElement);
}When using registerRowDragger you should not set the property rowDrag=true in the Column Definition. Doing that will cause the cell to have two row draggers.
Full Width Row Dragging Copy Link
It is possible to drag Full Width Rows by registering a Custom Row Dragger.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowHeight,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IsFullWidthRow,
IsFullWidthRowParams,
ModuleRegistry,
RowDragModule,
RowHeightParams,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
RowDragModule,
ClientSideRowModelModule,
]);
import { FullWidthCellRenderer } from "./full-width-cell-renderer.component";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, FullWidthCellRenderer],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
[rowDragManaged]="true"
[getRowHeight]="getRowHeight"
[isFullWidthRow]="isFullWidthRow"
[fullWidthCellRenderer]="fullWidthCellRenderer"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "name", cellRenderer: countryCellRenderer },
{ field: "continent" },
{ field: "language" },
];
defaultColDef: ColDef = {
flex: 1,
filter: true,
};
rowData: any[] | null = getData();
getRowHeight: GetRowHeight = (params: RowHeightParams) => {
// return 100px height for full width rows
if (isFullWidth(params.data)) {
return 100;
}
};
isFullWidthRow: IsFullWidthRow = (params: IsFullWidthRowParams) => {
return isFullWidth(params.rowNode.data);
};
fullWidthCellRenderer: any = FullWidthCellRenderer;
}
function countryCellRenderer(params: ICellRendererParams) {
if (!params.fullWidth) {
return params.value;
}
const flag =
'<img border="0" width="15" height="10" src="https://www.ag-grid.com/example-assets/flags/' +
params.data.code +
'.png">';
return (
'<span style="cursor: default;">' + flag + " " + params.value + "</span>"
);
}
function isFullWidth(data: any) {
// return true when country is Peru, France or Italy
return ["Peru", "France", "Italy"].indexOf(data.name) >= 0;
}
.full-width-panel {
/* undo the white-space setting Fresh puts in */
white-space: normal;
height: 100%;
width: 100%;
border: 2px solid grey;
border-style: ridge;
box-sizing: border-box;
padding: 5px;
background-color: #99999944;
}
.full-width-flag {
float: left;
padding: 6px;
}
.full-width-summary {
float: left;
/*margin-left: 10px;*/
margin-right: 10px;
}
.full-width-panel label {
padding-top: 3px;
display: inline-block;
font-size: 12px;
}
.full-width-center {
overflow-y: scroll;
border: 1px solid grey;
padding: 2px;
height: 100%;
box-sizing: border-box;
font-family: cursive;
background-color: #99999944;
}
.full-width-center p {
margin-top: 0px;
}
.full-width-title {
font-size: 20px;
}
export function getData(): any[] {
const rowData = [
{
// these attributes appear in the top level rows of the grid
name: 'Ireland',
continent: 'Europe',
language: 'English',
code: 'ie',
// these are used in the panel
population: 4000000,
},
// and then repeat for all the other countries
{
name: 'Spain',
continent: 'Europe',
language: 'Spanish',
code: 'es',
population: 4000000,
},
{
name: 'United Kingdom',
continent: 'Europe',
language: 'English',
code: 'gb',
population: 4000000,
},
{
name: 'France',
continent: 'Europe',
language: 'French',
code: 'fr',
population: 4000000,
},
{
name: 'Germany',
continent: 'Europe',
language: 'German',
code: 'de',
population: 4000000,
},
{
name: 'Sweden',
continent: 'Europe',
language: 'Swedish',
code: 'se',
population: 4000000,
},
{
name: 'Norway',
continent: 'Europe',
language: 'Norwegian',
code: 'no',
population: 4000000,
},
{
name: 'Italy',
continent: 'Europe',
language: 'Italian',
code: 'it',
population: 4000000,
},
{
name: 'Greece',
continent: 'Europe',
language: 'Greek',
code: 'gr',
population: 4000000,
},
{
name: 'Iceland',
continent: 'Europe',
language: 'Icelandic',
code: 'is',
population: 4000000,
},
{
name: 'Portugal',
continent: 'Europe',
language: 'Portuguese',
code: 'pt',
population: 4000000,
},
{
name: 'Malta',
continent: 'Europe',
language: 'Maltese',
code: 'mt',
population: 4000000,
},
{
name: 'Brazil',
continent: 'South America',
language: 'Portuguese',
code: 'br',
population: 4000000,
},
{
name: 'Argentina',
continent: 'South America',
language: 'Spanish',
code: 'ar',
population: 4000000,
},
{
name: 'Colombia',
continent: 'South America',
language: 'Spanish',
code: 'co',
population: 4000000,
},
{
name: 'Peru',
continent: 'South America',
language: 'Spanish',
code: 'pe',
population: 4000000,
},
{
name: 'Venezuela',
continent: 'South America',
language: 'Spanish',
code: 've',
population: 4000000,
},
{
name: 'Uruguay',
continent: 'South America',
language: 'Spanish',
code: 'uy',
population: 4000000,
},
];
return rowData;
}
import { ChangeDetectionStrategy, Component, signal } from '@angular/core';
import type { ICellRendererAngularComp } from 'ag-grid-angular';
import type { ICellRendererParams } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `
<div class="full-width-panel">
<div class="full-width-flag">
<img border="0" [src]="flag()" />
</div>
<div class="full-width-summary">
<span class="full-width-title">{{ data()?.name }}</span>
<br />
<label>
<b>Population:</b>
{{ data()?.population }}
</label>
<br />
<label>
<b>Language:</b>
{{ data()?.language }}
</label>
<br />
</div>
<div
class="full-width-center"
(mousewheel)="mouseWheelListener($event)"
(DOMMouseScroll)="mouseWheelListener($event)"
>
{{ latinText() }}
</div>
</div>
`,
styles: [
`
.full-width-panel {
/* undo the white-space setting Fresh puts in */
white-space: normal;
height: 100%;
width: 100%;
border: 2px solid grey;
border-style: ridge;
padding: 5px;
background-color: #99999944;
}
.full-width-flag {
float: left;
padding: 6px;
}
.full-width-summary {
float: left;
/*margin-left: 10px;*/
margin-right: 10px;
}
.full-width-panel label {
padding-top: 3px;
display: inline-block;
font-size: 12px;
}
.full-width-center {
overflow-y: scroll;
border: 1px solid grey;
padding: 2px;
height: 100%;
font-family: cursive;
background-color: #99999944;
}
.full-width-center p {
margin-top: 0px;
}
.full-width-title {
font-size: 20px;
}
`,
],
})
export class FullWidthCellRenderer implements ICellRendererAngularComp {
data = signal<any>(undefined);
flag = signal<string>('');
agInit(params: ICellRendererParams): void {
const data = params.node.data;
this.data.set(data);
this.flag.set(`https://www.ag-grid.com/example-assets/large-flags/${data.code}.png`);
params.registerRowDragger(params.eParentOfValue, undefined, data.name, true);
}
mouseWheelListener(event: Event) {
event.stopPropagation();
}
latinText() {
return '<p>Sample Text in a Paragraph</p><p>Lorem ipsum dolor sit amet, his mazim necessitatibus te, mea volutpat intellegebat at. Ea nec perpetua liberavisse, et modo rebum persius pri. Velit recteque reprimique quo at. Vis ex persius oporteat, esse voluptatum moderatius te vis. Ex agam suscipit aliquando eum. Mediocrem molestiae id pri, ei cibo facilisis mel. Ne sale nonumy sea. Et vel lorem omittam vulputate. Ne prima impedit percipitur vis, erat summo an pro. Id urbanitas deterruisset cum, at legere oportere has. No saperet lobortis elaboraret qui, alii zril at vix, nulla soluta ornatus per ad. Feugiat consequuntur vis ad, te sit quodsi persequeris, labore perpetua mei ad. Ex sea affert ullamcorper disputationi, sit nisl elit elaboraret te, quodsi doctus verear ut eam. Eu vel malis nominati, per ex melius delenit incorrupte. Partem complectitur sed in. Vix dicta tincidunt ea. Id nec urbanitas voluptaria, pri no nostro disputationi. Falli graeco salutatus pri ea.</p><p>Quo ad omnesque phaedrum principes, tale urbanitas constituam et ius, pericula consequat ad est. Ius tractatos referrentur deterruisset an, odio consequuntur sed ad. Ea molestie adipiscing adversarium eos, tale veniam sea no. Mutat nullam philosophia sed ad. Pri eu dicta consulatu, te mollis quaerendum sea. Ei doming commodo euismod vis. Cu modus aliquip inermis his, eos et eirmod regione delicata, at odio definiebas vis.</p><p>Lorem ipsum dolor sit amet, his mazim necessitatibus te, mea volutpat intellegebat at. Ea nec perpetua liberavisse, et modo rebum persius pri. Velit recteque reprimique quo at. Vis ex persius oporteat, esse voluptatum moderatius te vis. Ex agam suscipit aliquando eum. Mediocrem molestiae id pri, ei cibo facilisis mel. Ne sale nonumy sea. Et vel lorem omittam vulputate. Ne prima impedit percipitur vis, erat summo an pro. Id urbanitas deterruisset cum, at legere oportere has. No saperet lobortis elaboraret qui, alii zril at vix, nulla soluta ornatus per ad. Feugiat consequuntur vis ad, te sit quodsi persequeris, labore perpetua mei ad. Ex sea affert ullamcorper disputationi, sit nisl elit elaboraret te, quodsi doctus verear ut eam. Eu vel malis nominati, per ex melius delenit incorrupte. Partem complectitur sed in. Vix dicta tincidunt ea. Id nec urbanitas voluptaria, pri no nostro disputationi. Falli graeco salutatus pri ea.</p><p>Quo ad omnesque phaedrum principes, tale urbanitas constituam et ius, pericula consequat ad est. Ius tractatos referrentur deterruisset an, odio consequuntur sed ad. Ea molestie adipiscing adversarium eos, tale veniam sea no. Mutat nullam philosophia sed ad. Pri eu dicta consulatu, te mollis quaerendum sea. Ei doming commodo euismod vis. Cu modus aliquip inermis his, eos et eirmod regione delicata, at odio definiebas vis.</p>';
}
refresh(params: ICellRendererParams): boolean {
return false;
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
In the example above, only the full width rows are draggable.
Row Dragger with Custom Start Drag Pixels Copy Link
By default, the drag event only starts after the Row Drag Element has been dragged by 4px, but sometimes it might be useful to start the drag with a different drag threshold. For example, start dragging as soon as the mousedown event happens (dragged by 0px). For that reason, the registerRowDragger takes a second parameter to specify the number of pixels that will start the drag event.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragCancelEvent,
RowDragEndEvent,
RowDragEnterEvent,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
CellStyleModule,
ClientSideRowModelModule,
]);
import { CustomCellRenderer } from "./custom-cell-renderer.component";
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomCellRenderer],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowDragManaged]="true"
[rowData]="rowData"
(rowDragEnter)="onRowDragEnter($event)"
(rowDragEnd)="onRowDragEnd($event)"
(rowDragCancel)="onRowDragCancel($event)"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
field: "athlete",
cellClass: "custom-athlete-cell",
cellRenderer: CustomCellRenderer,
},
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
];
defaultColDef: ColDef = {
width: 170,
filter: true,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onRowDragEnter(e: RowDragEnterEvent) {
console.log("onRowDragEnter: node", e.node.id);
}
onRowDragEnd(e: RowDragEndEvent) {
console.log("onRowDragEnd: node", e.node.id);
}
onRowDragCancel(e: RowDragCancelEvent) {
console.log("onRowDragCancel: node", e.node.id);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.ag-ltr .ag-has-focus .ag-cell.custom-athlete-cell.ag-cell-focus:not(.ag-cell-range-selected) {
border: 1px solid #ff7b7b;
}
.ag-cell.custom-athlete-cell {
padding-left: 0;
padding-right: 0;
}
.ag-cell.custom-athlete-cell > div {
height: 100%;
}
.my-custom-cell-renderer {
display: flex;
font-size: 0.7rem;
background-color: #4180d6;
color: white;
padding: 0.25rem;
align-items: center;
justify-content: space-between;
box-sizing: border-box;
height: 100%;
}
.my-custom-cell-renderer > * {
line-height: normal;
}
.my-custom-cell-renderer i {
visibility: hidden;
cursor: move;
color: orange;
}
.my-custom-cell-renderer:hover i {
visibility: visible;
}
.my-custom-cell-renderer .athlete-info {
display: flex;
flex-direction: column;
width: 85px;
max-width: 85px;
}
.my-custom-cell-renderer .athlete-info > span {
overflow: hidden;
text-overflow: ellipsis;
}
import type { ElementRef } from '@angular/core';
import { ChangeDetectionStrategy, Component, HostBinding, ViewChild, signal } from '@angular/core';
import type { ICellRendererAngularComp } from 'ag-grid-angular';
import type { ICellRendererParams } from 'ag-grid-community';
@Component({
standalone: true,
changeDetection: ChangeDetectionStrategy.OnPush,
template: `<div class="athlete-info">
<span>{{ data()?.athlete }}</span>
<span>{{ data()?.country }}</span>
</div>
<span>{{ data()?.year }}</span>
<i class="fas fa-arrows-alt-v" #myref></i>`,
})
export class CustomCellRenderer implements ICellRendererAngularComp {
data = signal(undefined);
private cellRendererParams!: ICellRendererParams;
@ViewChild('myref') myRef!: ElementRef;
@HostBinding('class') class = 'my-custom-cell-renderer';
agInit(params: ICellRendererParams): void {
this.cellRendererParams = params;
this.data.set(params.data);
}
ngAfterViewInit() {
this.cellRendererParams.registerRowDragger(this.myRef.nativeElement, 0);
}
refresh(params: ICellRendererParams): boolean {
return false;
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} In the example above, the drag event starts as soon as mousedown is fired.
Custom Drag and Drop Image Copy Link
The drag and drop image can be customised via the grid properties dragAndDropImageComponent and dragAndDropImageComponentParams.
Implement this interface to provide a custom drag and drop image component when dragging parts of the grid.
IDragAndDropImageAngularComponent Copy Link
interface IDragAndDropImageAngularComponent {
// Mandatory - Params for rendering this component.
agInit(params: IDragAndDropImageParams): void;
setIcon(iconName: string | null, shake: boolean): void;
setLabel(label: string): void;
} IDragAndDropImageParams Copy Link
DragSource |
The grid api. |
Application context as set on gridOptions.context. |
Custom Params Copy Link
On top of the parameters provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the component. For example, you might have parts of the grid that you want to highlight with a different colour.
colDef = {
dragAndDropImageComponent: MyDragAndDropImageComponent,
dragAndDropImageComponentParams : {
accentColour: 'SlateGray'
}
}import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
ClientSideRowModelModule,
]);
import { CustomDragAndDropImage } from "./custom-drag-and-drop-image.component";
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular, CustomDragAndDropImage],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowDragManaged]="true"
[dragAndDropImageComponent]="dragAndDropImageComponent"
[dragAndDropImageComponentParams]="dragAndDropImageComponentParams"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", rowDrag: true },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
];
defaultColDef: ColDef = {
width: 170,
filter: true,
};
dragAndDropImageComponent: any = CustomDragAndDropImage;
dragAndDropImageComponentParams: any = {
accentColour: "SlateGray",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.my-custom-drag-and-drop-cover {
padding: 2rem;
color: white;
cursor: move;
display: flex;
align-items: center;
gap: 0.5rem;
border-radius: 0.5rem;
}
import { Component, ElementRef, ViewChild } from '@angular/core';
import type { IDragAndDropImageAngularComponent } from 'ag-grid-angular';
import type { IDragAndDropImageParams } from 'ag-grid-community';
@Component({
standalone: true,
template: `
<div #eImage class="my-custom-drag-and-drop-cover">
<i #eIcon class="fas fa-2x"></i>
<div #eLabel></div>
</div>
`,
styles: [
`
.my-custom-drag-and-drop-cover {
padding: 2rem;
color: white !important;
cursor: move;
display: flex;
align-items: center;
border-radius: 0.5rem;
gap: 0.5rem;
}
`,
],
})
export class CustomDragAndDropImage implements IDragAndDropImageAngularComponent {
public params!: IDragAndDropImageParams & { accentColour: string };
@ViewChild('eImage', { read: ElementRef }) public eImage!: ElementRef;
@ViewChild('eIcon', { read: ElementRef }) public eIcon!: ElementRef;
@ViewChild('eLabel', { read: ElementRef }) public eLabel!: ElementRef;
agInit(params: IDragAndDropImageParams & { accentColour: string }): void {
this.params = params;
}
ngAfterViewInit() {
this.eImage.nativeElement.style.setProperty('background-color', this.params.accentColour);
}
setLabel(label: string) {
this.eLabel.nativeElement.innerHTML = label;
}
setIcon(icon: string) {
const { eIcon, params } = this;
const { nativeElement } = eIcon;
const { dragSource } = params;
if (!nativeElement || !dragSource) {
return;
}
if (!icon) {
icon = dragSource.getDefaultIconName ? dragSource.getDefaultIconName() : 'notAllowed';
}
if (icon === 'hide' && params.api.getGridOption('suppressDragLeaveHidesColumns')) {
return;
}
nativeElement.classList.toggle('fa-hand-point-left', icon === 'left');
nativeElement.classList.toggle('fa-hand-point-right', icon === 'right');
nativeElement.classList.toggle('fa-ban', icon === 'notAllowed');
nativeElement.classList.toggle('fa-mask', icon === 'hide');
nativeElement.classList.toggle('fa-thumbtack', icon === 'pinned');
nativeElement.classList.toggle('fa-walking', icon === 'move');
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}

There are some options that can be used to customise the Row Drag experience, so it has a better integration with your application.
Entire Row Dragging Copy Link
When using row dragging it is also possible to reorder rows by clicking and dragging anywhere on the row without the need for a drag handle by enabling the rowDragEntireRow grid option.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete" },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 170,
filter: true,
};
}, []);
const rowSelection = useMemo<
RowSelectionOptions | "single" | "multiple"
>(() => {
return { mode: "multiRow" };
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowDragManaged={true}
rowDragEntireRow={true}
rowDragMultiRow={true}
rowSelection={rowSelection}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; The example above demonstrates entire row dragging with Multi-Row Dragging. Note the following:
- Reordering rows by clicking and dragging anywhere on a row is possible as
rowDragEntireRowis enabled. - Multiple rows can be selected and dragged as
rowDragMultiRowis also enabled withrowSelection.mode = 'multiRow'. - Row Drag Managed is being used, but it is not a requirement for Entire Row Dragging.
To enable entire row dragging, set the rowDragEntireRow property to true in the gridOptions as shown below:
const [columnDefs, setColumnDefs] = useState([
{ field: 'country' },
{ field: 'year' },
{ field: 'sport' },
{ field: 'total' }
]);
// allows rows to be dragged without the need for drag handles
const rowDragEntireRow = true;
<AgGridReact
columnDefs={columnDefs}
rowDragEntireRow={rowDragEntireRow}
/>Cell Selection is not supported when rowDragEntireRow is enabled.
Custom Row Drag Text Copy Link
When a row drag starts, a "floating" DOM element is created to indicate which row is being dragged. By default, this DOM element will contain the same value as the cell that started the row drag. It's possible to override that text by using the gridOptions.rowDragText callback.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
IRowDragItem,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowDragTextFunc,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
RowDragModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const rowDragText = useCallback(function (params: IRowDragItem) {
// keep double equals here because data can be a string or number
if (params.rowNode!.data.year == "2012") {
return params.defaultTextValue + " (London Olympics)";
}
return params.defaultTextValue;
}, []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", rowDrag: true },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 170,
filter: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
rowDragText={rowDragText}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowDragManaged={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; The example above shows dragging with custom text. The following can be noted:
- When you drag a row of the year 2012, the
rowDragTextcallback will add (London Olympics) to the floating drag element.
To enable custom row drag text, set the rowDragText callback in the gridOptions as shown below:
const [columnDefs, setColumnDefs] = useState([
{
field: 'athlete',
rowDrag: true
}, {
field: 'country'
}
]);
const rowDragText = (params, dragItemCount) => {
return (
dragItemCount > 1
? (dragItemCount + ' items')
: params.defaultTextValue + ' is'
) + ' being dragged...';
};
<AgGridReact
columnDefs={columnDefs}
rowDragText={rowDragText}
/>A callback that should return a string to be displayed by the rowDragComp while dragging a row.
If this callback is not set, the current cell value will be used.
If the rowDragText callback is set in the ColDef it will take precedence over this, except when
rowDragEntireRow=true. |
Custom Row Drag Text with Multiple Draggers Copy Link
If the grid has more than one column set with rowDrag=true, the rowDragText callback can be set in the colDef.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
IRowDragItem,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowDragTextFunc,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
ClientSideRowModelModule,
];
const athleteRowDragTextCallback = function (
params: IRowDragItem,
dragItemCount: number,
) {
// keep double equals here because data can be a string or number
return `${dragItemCount} athlete(s) selected`;
};
const rowDragTextCallback = function (params: IRowDragItem) {
// keep double equals here because data can be a string or number
if (params.rowNode!.data.year == "2012") {
return params.defaultTextValue + " (London Olympics)";
}
return params.defaultTextValue;
};
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
field: "athlete",
rowDrag: true,
rowDragText: athleteRowDragTextCallback,
},
{ field: "country", rowDrag: true },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 170,
filter: true,
};
}, []);
const rowDragText = useCallback(rowDragTextCallback, []);
const rowSelection = useMemo<
RowSelectionOptions | "single" | "multiple"
>(() => {
return { mode: "multiRow" };
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowDragManaged={true}
rowDragText={rowDragText}
rowDragMultiRow={true}
rowSelection={rowSelection}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; The example above shows dragging with custom text and multiple column draggers. The following can be noted:
When you drag a row with a year of 2012 by the country row dragger, the
rowDragTextcallback will add (London Olympics) to the floating drag element.When you drag the row by the athlete row dragger, the
rowDragTextcallback in thegridOptionswill be overridden by the one in thecolDefand will display the number of athletes selected.
To enable custom row drag text per column dragger, set the rowDragText callback in the colDef as shown below:
const [columnDefs, setColumnDefs] = useState([
{
field: 'athlete',
rowDrag: true,
rowDragText: (params, dragItemCount) => {
const suffix = dragItemCount == 1 ? 'athlete' : 'athletes';
return `Dragging ${dragItemCount} ${suffix}`;
}
}, {
field: 'country',
rowDrag: true,
}
]);
const rowDragText = (params, dragItemCount) => {
return (
dragItemCount > 1
? (dragItemCount + ' items')
: params.defaultTextValue + ' is'
) + ' being dragged...';
};
<AgGridReact
columnDefs={columnDefs}
rowDragText={rowDragText}
/> Row Dragger inside Custom Cell Renderers Copy Link
Due to the complexity of some applications, it could be handy to render the Row Drag Component inside of a Custom Cell Renderer. This can be achieved by using the registerRowDragger method in the ICellRendererParams.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomCellRenderer from "./customCellRenderer.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
RowDragModule,
CellStyleModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
field: "athlete",
cellClass: "custom-athlete-cell",
cellRenderer: CustomCellRenderer,
},
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 170,
filter: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowDragManaged={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.ag-ltr .ag-cell.custom-athlete-cell.ag-cell-focus:not(.ag-cell-range-selected):focus-within {
border: 1px solid #ff7b7b;
}
.ag-cell.custom-athlete-cell {
padding-left: 0;
padding-right: 0;
}
.ag-cell.custom-athlete-cell > div {
height: 100%;
}
.my-custom-cell-renderer {
display: flex;
font-size: 0.7rem;
background-color: #4180d6;
color: white;
padding: 0.25rem;
align-items: center;
justify-content: space-between;
box-sizing: border-box;
height: 100%;
}
.my-custom-cell-renderer > * {
line-height: normal;
}
.my-custom-cell-renderer i {
visibility: hidden;
cursor: move;
color: orange;
}
.my-custom-cell-renderer:hover i {
visibility: visible;
}
.my-custom-cell-renderer .athlete-info {
display: flex;
flex-direction: column;
width: 85px;
max-width: 85px;
}
.my-custom-cell-renderer .athlete-info > span {
overflow: hidden;
text-overflow: ellipsis;
}
import React, { useEffect, useRef } from 'react';
import type { CustomCellRendererProps } from 'ag-grid-react';
const CustomCellRenderer = (props: CustomCellRendererProps) => {
const myRef = useRef(null);
useEffect(() => {
props.registerRowDragger(myRef.current!);
});
return (
<div className="my-custom-cell-renderer">
<div className="athlete-info">
<span>{props.data.athlete}</span>
<span>{props.data.country}</span>
</div>
<span>{props.data.year}</span>
<i className="fas fa-arrows-alt-v" ref={myRef}></i>
</div>
);
};
export default CustomCellRenderer;
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; The example above shows a custom cell renderer using the registerRowDragger callback to render the Row Dragger inside itself.
- When you hover the cells, an arrow will appear, and this arrow can be used to drag the rows.
To register a custom row dragger inside a custom cell renderer, use the registerRowDragger method from the ICellRendererParams as shown below:
// your custom cell renderer code
// this will hold the reference to the element you want to act as row dragger.
const myRef = useRef(null);
useEffect(() => {
props.registerRowDragger(myRef.current!);
});When using registerRowDragger you should not set the property rowDrag=true in the Column Definition. Doing that will cause the cell to have two row draggers.
Full Width Row Dragging Copy Link
It is possible to drag Full Width Rows by registering a Custom Row Dragger.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowHeight,
GridApi,
GridOptions,
ICellRendererParams,
IsFullWidthRow,
IsFullWidthRowParams,
ModuleRegistry,
RowDragModule,
RowHeightParams,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
import FullWidthCellRenderer from "./fullWidthCellRenderer.tsx";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [TextFilterModule, RowDragModule, ClientSideRowModelModule];
function countryCellRenderer(params: ICellRendererParams) {
if (!params.fullWidth) {
return params.value;
}
const flag =
'<img border="0" width="15" height="10" src="https://www.ag-grid.com/example-assets/flags/' +
params.data.code +
'.png">';
return (
'<span style="cursor: default;">' + flag + " " + params.value + "</span>"
);
}
function isFullWidth(data: any) {
// return true when country is Peru, France or Italy
return ["Peru", "France", "Italy"].indexOf(data.name) >= 0;
}
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "name", cellRenderer: countryCellRenderer },
{ field: "continent" },
{ field: "language" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
filter: true,
};
}, []);
const getRowHeight = useCallback((params: RowHeightParams) => {
// return 100px height for full width rows
if (isFullWidth(params.data)) {
return 100;
}
}, []);
const isFullWidthRow = useCallback((params: IsFullWidthRowParams) => {
return isFullWidth(params.rowNode.data);
}, []);
const fullWidthCellRenderer = useCallback(FullWidthCellRenderer, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowDragManaged={true}
getRowHeight={getRowHeight}
isFullWidthRow={isFullWidthRow}
fullWidthCellRenderer={fullWidthCellRenderer}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.full-width-panel {
/* undo the white-space setting Fresh puts in */
white-space: normal;
height: 100%;
width: 100%;
border: 2px solid grey;
border-style: ridge;
box-sizing: border-box;
padding: 5px;
background-color: #99999944;
}
.full-width-flag {
float: left;
padding: 6px;
}
.full-width-summary {
float: left;
/*margin-left: 10px;*/
margin-right: 10px;
}
.full-width-panel label {
padding-top: 3px;
display: inline-block;
font-size: 12px;
}
.full-width-center {
overflow-y: scroll;
border: 1px solid grey;
padding: 2px;
height: 100%;
box-sizing: border-box;
font-family: cursive;
background-color: #99999944;
}
.full-width-center p {
margin-top: 0px;
}
.full-width-title {
font-size: 20px;
}
export function getData(): any[] {
const rowData = [
{
// these attributes appear in the top level rows of the grid
name: 'Ireland',
continent: 'Europe',
language: 'English',
code: 'ie',
// these are used in the panel
population: 4000000,
},
// and then repeat for all the other countries
{
name: 'Spain',
continent: 'Europe',
language: 'Spanish',
code: 'es',
population: 4000000,
},
{
name: 'United Kingdom',
continent: 'Europe',
language: 'English',
code: 'gb',
population: 4000000,
},
{
name: 'France',
continent: 'Europe',
language: 'French',
code: 'fr',
population: 4000000,
},
{
name: 'Germany',
continent: 'Europe',
language: 'German',
code: 'de',
population: 4000000,
},
{
name: 'Sweden',
continent: 'Europe',
language: 'Swedish',
code: 'se',
population: 4000000,
},
{
name: 'Norway',
continent: 'Europe',
language: 'Norwegian',
code: 'no',
population: 4000000,
},
{
name: 'Italy',
continent: 'Europe',
language: 'Italian',
code: 'it',
population: 4000000,
},
{
name: 'Greece',
continent: 'Europe',
language: 'Greek',
code: 'gr',
population: 4000000,
},
{
name: 'Iceland',
continent: 'Europe',
language: 'Icelandic',
code: 'is',
population: 4000000,
},
{
name: 'Portugal',
continent: 'Europe',
language: 'Portuguese',
code: 'pt',
population: 4000000,
},
{
name: 'Malta',
continent: 'Europe',
language: 'Maltese',
code: 'mt',
population: 4000000,
},
{
name: 'Brazil',
continent: 'South America',
language: 'Portuguese',
code: 'br',
population: 4000000,
},
{
name: 'Argentina',
continent: 'South America',
language: 'Spanish',
code: 'ar',
population: 4000000,
},
{
name: 'Colombia',
continent: 'South America',
language: 'Spanish',
code: 'co',
population: 4000000,
},
{
name: 'Peru',
continent: 'South America',
language: 'Spanish',
code: 'pe',
population: 4000000,
},
{
name: 'Venezuela',
continent: 'South America',
language: 'Spanish',
code: 've',
population: 4000000,
},
{
name: 'Uruguay',
continent: 'South America',
language: 'Spanish',
code: 'uy',
population: 4000000,
},
];
return rowData;
}
import React, { useEffect, useRef } from 'react';
import type { CustomCellRendererProps } from 'ag-grid-react';
const FullWidthCellRenderer = (props: CustomCellRendererProps) => {
const myRef = useRef<HTMLDivElement>(null);
const stopPropagation = (e: Event) => e.stopPropagation();
useEffect(() => {
const element = myRef.current;
if (element) {
element.addEventListener('mousewheel', stopPropagation);
return () => {
element.removeEventListener('mousewheel', stopPropagation);
};
}
});
const latinText = () =>
'<p>Sample Text in a Paragraph</p><p>Lorem ipsum dolor sit amet, his mazim necessitatibus te, mea volutpat intellegebat at. Ea nec perpetua liberavisse, et modo rebum persius pri. Velit recteque reprimique quo at. Vis ex persius oporteat, esse voluptatum moderatius te vis. Ex agam suscipit aliquando eum. Mediocrem molestiae id pri, ei cibo facilisis mel. Ne sale nonumy sea. Et vel lorem omittam vulputate. Ne prima impedit percipitur vis, erat summo an pro. Id urbanitas deterruisset cum, at legere oportere has. No saperet lobortis elaboraret qui, alii zril at vix, nulla soluta ornatus per ad. Feugiat consequuntur vis ad, te sit quodsi persequeris, labore perpetua mei ad. Ex sea affert ullamcorper disputationi, sit nisl elit elaboraret te, quodsi doctus verear ut eam. Eu vel malis nominati, per ex melius delenit incorrupte. Partem complectitur sed in. Vix dicta tincidunt ea. Id nec urbanitas voluptaria, pri no nostro disputationi. Falli graeco salutatus pri ea.</p><p>Quo ad omnesque phaedrum principes, tale urbanitas constituam et ius, pericula consequat ad est. Ius tractatos referrentur deterruisset an, odio consequuntur sed ad. Ea molestie adipiscing adversarium eos, tale veniam sea no. Mutat nullam philosophia sed ad. Pri eu dicta consulatu, te mollis quaerendum sea. Ei doming commodo euismod vis. Cu modus aliquip inermis his, eos et eirmod regione delicata, at odio definiebas vis.</p><p>Lorem ipsum dolor sit amet, his mazim necessitatibus te, mea volutpat intellegebat at. Ea nec perpetua liberavisse, et modo rebum persius pri. Velit recteque reprimique quo at. Vis ex persius oporteat, esse voluptatum moderatius te vis. Ex agam suscipit aliquando eum. Mediocrem molestiae id pri, ei cibo facilisis mel. Ne sale nonumy sea. Et vel lorem omittam vulputate. Ne prima impedit percipitur vis, erat summo an pro. Id urbanitas deterruisset cum, at legere oportere has. No saperet lobortis elaboraret qui, alii zril at vix, nulla soluta ornatus per ad. Feugiat consequuntur vis ad, te sit quodsi persequeris, labore perpetua mei ad. Ex sea affert ullamcorper disputationi, sit nisl elit elaboraret te, quodsi doctus verear ut eam. Eu vel malis nominati, per ex melius delenit incorrupte. Partem complectitur sed in. Vix dicta tincidunt ea. Id nec urbanitas voluptaria, pri no nostro disputationi. Falli graeco salutatus pri ea.</p><p>Quo ad omnesque phaedrum principes, tale urbanitas constituam et ius, pericula consequat ad est. Ius tractatos referrentur deterruisset an, odio consequuntur sed ad. Ea molestie adipiscing adversarium eos, tale veniam sea no. Mutat nullam philosophia sed ad. Pri eu dicta consulatu, te mollis quaerendum sea. Ei doming commodo euismod vis. Cu modus aliquip inermis his, eos et eirmod regione delicata, at odio definiebas vis.</p>';
props.registerRowDragger(props.eParentOfValue, undefined, props.data.name, true);
return (
<div className="full-width-panel">
<div className="full-width-flag">
<img src={`https://www.ag-grid.com/example-assets/large-flags/${props.node.data.code}.png`} />
</div>
<div className="full-width-summary">
<span className="full-width-title">{props.node.data.name}</span>
<br />
<label>
<b>Population:</b>
{props.node.data.population}
</label>
<br />
<label>
<b>Language:</b>
{props.node.data.language}
</label>
<br />
</div>
<div className="full-width-center" ref={myRef}>
{latinText()}
</div>
</div>
);
};
export default FullWidthCellRenderer;
In the example above, only the full width rows are draggable.
Row Dragger with Custom Start Drag Pixels Copy Link
By default, the drag event only starts after the Row Drag Element has been dragged by 4px, but sometimes it might be useful to start the drag with a different drag threshold. For example, start dragging as soon as the mousedown event happens (dragged by 0px). For that reason, the registerRowDragger takes a second parameter to specify the number of pixels that will start the drag event.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
RowDragCancelEvent,
RowDragEndEvent,
RowDragEnterEvent,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomCellRenderer from "./customCellRenderer.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
RowDragModule,
CellStyleModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
field: "athlete",
cellClass: "custom-athlete-cell",
cellRenderer: CustomCellRenderer,
},
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 170,
filter: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
const onRowDragEnter = useCallback((e: RowDragEnterEvent) => {
console.log("onRowDragEnter: node", e.node.id);
}, []);
const onRowDragEnd = useCallback((e: RowDragEndEvent) => {
console.log("onRowDragEnd: node", e.node.id);
}, []);
const onRowDragCancel = useCallback((e: RowDragCancelEvent) => {
console.log("onRowDragCancel: node", e.node.id);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowDragManaged={true}
onRowDragEnter={onRowDragEnter}
onRowDragEnd={onRowDragEnd}
onRowDragCancel={onRowDragCancel}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.ag-ltr .ag-has-focus .ag-cell.custom-athlete-cell.ag-cell-focus:not(.ag-cell-range-selected) {
border: 1px solid #ff7b7b;
}
.ag-cell.custom-athlete-cell {
padding-left: 0;
padding-right: 0;
}
.ag-cell.custom-athlete-cell > div {
height: 100%;
}
.my-custom-cell-renderer {
display: flex;
font-size: 0.7rem;
background-color: #4180d6;
color: white;
padding: 0.25rem;
align-items: center;
justify-content: space-between;
box-sizing: border-box;
height: 100%;
}
.my-custom-cell-renderer > * {
line-height: normal;
}
.my-custom-cell-renderer i {
visibility: hidden;
cursor: move;
color: orange;
}
.my-custom-cell-renderer:hover i {
visibility: visible;
}
.my-custom-cell-renderer .athlete-info {
display: flex;
flex-direction: column;
width: 85px;
max-width: 85px;
}
.my-custom-cell-renderer .athlete-info > span {
overflow: hidden;
text-overflow: ellipsis;
}
import React, { useEffect, useRef } from 'react';
import type { CustomCellRendererProps } from 'ag-grid-react';
const CustomCellRenderer = (props: CustomCellRendererProps) => {
const myRef = useRef(null);
useEffect(() => {
props.registerRowDragger(myRef.current!, 0);
});
return (
<div className="my-custom-cell-renderer">
<div className="athlete-info">
<span>{props.data.athlete}</span>
<span>{props.data.country}</span>
</div>
<span>{props.data.year}</span>
<i className="fas fa-arrows-alt-v" ref={myRef}></i>
</div>
);
};
export default CustomCellRenderer;
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; In the example above, the drag event starts as soon as mousedown is fired.
Custom Drag and Drop Image Copy Link
The drag and drop image can be customised via the grid properties dragAndDropImageComponent and dragAndDropImageComponentParams.
const CustomDragAndDropImage = (props: CustomDragAndDropImageProps) => {
return <div>{props.label}</div>;
};The following props are passed to the Custom Component (CustomDragAndDropImageProps interface).
CustomDragAndDropImageProps Copy Link
The label provided by the grid about the item being dragged. |
The name of the icon provided by the grid about the current drop target. |
true if the grid is attempting to scroll horizontally while dragging. |
DragSource |
The grid api. |
Application context as set on gridOptions.context. |
Custom Params Copy Link
On top of the parameters provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the component. For example, you might have parts of the grid that you want to highlight with a different colour.
colDef = {
dragAndDropImageComponent: MyDragAndDropImageComponent,
dragAndDropImageComponentParams : {
accentColour: 'SlateGray'
}
}"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomDragAndDropImage from "./customDragAndDropImage.tsx";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextFilterModule,
NumberFilterModule,
RowDragModule,
ClientSideRowModelModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", rowDrag: true },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
width: 170,
filter: true,
};
}, []);
const dragAndDropImageComponent = useCallback(CustomDragAndDropImage, []);
const dragAndDropImageComponentParams = useMemo(() => {
return {
accentColour: "SlateGray",
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
rowDragManaged={true}
dragAndDropImageComponent={dragAndDropImageComponent}
dragAndDropImageComponentParams={dragAndDropImageComponentParams}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.my-custom-drag-and-drop-cover {
padding: 2rem;
color: white;
cursor: move;
display: flex;
align-items: center;
gap: 0.5rem;
border-radius: 0.5rem;
}
import React from 'react';
import type { CustomDragAndDropImageProps } from 'ag-grid-react';
export default (props: CustomDragAndDropImageProps & { accentColour: string }) => {
const getIcon = (icon: string | null): string | undefined => {
const { dragSource, api } = props;
if (!icon) {
icon = dragSource.getDefaultIconName ? dragSource.getDefaultIconName() : 'notAllowed';
}
if (icon === 'hide' && api.getGridOption('suppressDragLeaveHidesColumns')) {
return '';
}
if (icon === 'left') {
return 'fa-hand-point-left';
}
if (icon === 'right') {
return 'fa-hand-point-right';
}
if (icon === 'hide') {
return 'fa-mask';
}
if (icon === 'notAllowed') {
return 'fa-ban';
}
if (icon === 'pinned') {
return 'fa-thumbtack';
}
return 'fa-walking';
};
return (
<div className="my-custom-drag-and-drop-cover" style={{ backgroundColor: props.accentColour }}>
<i className={`fas fa-2x ${getIcon(props.icon)}`}></i>
<div>{props.label}</div>
</div>
);
};
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
};

There are some options that can be used to customise the Row Drag experience, so it has a better integration with your application.
Entire Row Dragging Copy Link
When using row dragging it is also possible to reorder rows by clicking and dragging anywhere on the row without the need for a drag handle by enabling the rowDragEntireRow grid option.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowDragManaged="true"
:rowDragEntireRow="true"
:rowDragMultiRow="true"
:rowSelection="rowSelection"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete" },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = ref<ColDef>({
width: 170,
filter: true,
});
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowSelection,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above demonstrates entire row dragging with Multi-Row Dragging. Note the following:
- Reordering rows by clicking and dragging anywhere on a row is possible as
rowDragEntireRowis enabled. - Multiple rows can be selected and dragged as
rowDragMultiRowis also enabled withrowSelection.mode = 'multiRow'. - Row Drag Managed is being used, but it is not a requirement for Entire Row Dragging.
To enable entire row dragging, set the rowDragEntireRow property to true in the gridOptions as shown below:
<ag-grid-vue
:columnDefs="columnDefs"
:rowDragEntireRow="rowDragEntireRow"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{ field: 'country' },
{ field: 'year' },
{ field: 'sport' },
{ field: 'total' }
];
// allows rows to be dragged without the need for drag handles
this.rowDragEntireRow = true;Cell Selection is not supported when rowDragEntireRow is enabled.
Custom Row Drag Text Copy Link
When a row drag starts, a "floating" DOM element is created to indicate which row is being dragged. By default, this DOM element will contain the same value as the cell that started the row drag. It's possible to override that text by using the gridOptions.rowDragText callback.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IRowDragItem,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowDragTextFunc,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:rowDragText="rowDragText"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowDragManaged="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const rowDragText = ref<RowDragTextFunc>(function (params: IRowDragItem) {
// keep double equals here because data can be a string or number
if (params.rowNode!.data.year == "2012") {
return params.defaultTextValue + " (London Olympics)";
}
return params.defaultTextValue;
});
const columnDefs = ref<ColDef[]>([
{ field: "athlete", rowDrag: true },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = ref<ColDef>({
width: 170,
filter: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
rowDragText,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above shows dragging with custom text. The following can be noted:
- When you drag a row of the year 2012, the
rowDragTextcallback will add (London Olympics) to the floating drag element.
To enable custom row drag text, set the rowDragText callback in the gridOptions as shown below:
<ag-grid-vue
:columnDefs="columnDefs"
:rowDragText="rowDragText"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'athlete',
rowDrag: true
}, {
field: 'country'
}
];
this.rowDragText = (params, dragItemCount) => {
return (
dragItemCount > 1
? (dragItemCount + ' items')
: params.defaultTextValue + ' is'
) + ' being dragged...';
};A callback that should return a string to be displayed by the rowDragComp while dragging a row.
If this callback is not set, the current cell value will be used.
If the rowDragText callback is set in the ColDef it will take precedence over this, except when
rowDragEntireRow=true. |
Custom Row Drag Text with Multiple Draggers Copy Link
If the grid has more than one column set with rowDrag=true, the rowDragText callback can be set in the colDef.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IRowDragItem,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
RowDragTextFunc,
RowSelectionModule,
RowSelectionOptions,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
RowSelectionModule,
ClientSideRowModelModule,
]);
const athleteRowDragTextCallback = function (
params: IRowDragItem,
dragItemCount: number,
) {
// keep double equals here because data can be a string or number
return `${dragItemCount} athlete(s) selected`;
};
const rowDragTextCallback = function (params: IRowDragItem) {
// keep double equals here because data can be a string or number
if (params.rowNode!.data.year == "2012") {
return params.defaultTextValue + " (London Olympics)";
}
return params.defaultTextValue;
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowDragManaged="true"
:rowDragText="rowDragText"
:rowDragMultiRow="true"
:rowSelection="rowSelection"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
rowDrag: true,
rowDragText: athleteRowDragTextCallback,
},
{ field: "country", rowDrag: true },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = ref<ColDef>({
width: 170,
filter: true,
});
const rowDragText = ref<RowDragTextFunc>(rowDragTextCallback);
const rowSelection = ref<RowSelectionOptions | "single" | "multiple">({
mode: "multiRow",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowDragText,
rowSelection,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The example above shows dragging with custom text and multiple column draggers. The following can be noted:
When you drag a row with a year of 2012 by the country row dragger, the
rowDragTextcallback will add (London Olympics) to the floating drag element.When you drag the row by the athlete row dragger, the
rowDragTextcallback in thegridOptionswill be overridden by the one in thecolDefand will display the number of athletes selected.
To enable custom row drag text per column dragger, set the rowDragText callback in the colDef as shown below:
<ag-grid-vue
:columnDefs="columnDefs"
:rowDragText="rowDragText"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'athlete',
rowDrag: true,
rowDragText: (params, dragItemCount) => {
const suffix = dragItemCount == 1 ? 'athlete' : 'athletes';
return `Dragging ${dragItemCount} ${suffix}`;
}
}, {
field: 'country',
rowDrag: true,
}
];
this.rowDragText = (params, dragItemCount) => {
return (
dragItemCount > 1
? (dragItemCount + ' items')
: params.defaultTextValue + ' is'
) + ' being dragged...';
}; Row Dragger inside Custom Cell Renderers Copy Link
Due to the complexity of some applications, it could be handy to render the Row Drag Component inside of a Custom Cell Renderer. This can be achieved by using the registerRowDragger method in the ICellRendererParams.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomCellRenderer from "./customCellRendererVue";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
CellStyleModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowDragManaged="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomCellRenderer,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
cellClass: "custom-athlete-cell",
cellRenderer: "CustomCellRenderer",
},
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = ref<ColDef>({
width: 170,
filter: true,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.ag-ltr .ag-cell.custom-athlete-cell.ag-cell-focus:not(.ag-cell-range-selected):focus-within {
border: 1px solid #ff7b7b;
}
.ag-cell.custom-athlete-cell {
padding-left: 0;
padding-right: 0;
}
.ag-cell.custom-athlete-cell > div {
height: 100%;
}
.my-custom-cell-renderer {
display: flex;
font-size: 0.7rem;
background-color: #4180d6;
color: white;
padding: 0.25rem;
align-items: center;
justify-content: space-between;
box-sizing: border-box;
height: 100%;
}
.my-custom-cell-renderer > * {
line-height: normal;
}
.my-custom-cell-renderer i {
visibility: hidden;
cursor: move;
color: orange;
}
.my-custom-cell-renderer:hover i {
visibility: visible;
}
.my-custom-cell-renderer .athlete-info {
display: flex;
flex-direction: column;
width: 85px;
max-width: 85px;
}
.my-custom-cell-renderer .athlete-info > span {
overflow: hidden;
text-overflow: ellipsis;
}
export default {
template: `
<div class="my-custom-cell-renderer">
<div class="athlete-info">
<span>{{ athlete }}</span>
<span>{{ country }}</span>
</div>
<span>{{ year }}</span>
<i class="fas fa-arrows-alt-v" ref="myRef"></i>
</div>`,
data: function () {
return {
athlete: '',
country: '',
year: '',
};
},
beforeMount() {
this.athlete = this.params.data.athlete;
this.country = this.params.data.country;
this.year = this.params.data.year;
},
mounted() {
this.params.registerRowDragger(this.$refs.myRef);
},
};
The example above shows a custom cell renderer using the registerRowDragger callback to render the Row Dragger inside itself.
- When you hover the cells, an arrow will appear, and this arrow can be used to drag the rows.
To register a custom row dragger inside a custom cell renderer, use the registerRowDragger method from the ICellRendererParams as shown below:
// your custom cell renderer code
mounted() {
this.params.registerRowDragger(this.$refs.myRef);
}When using registerRowDragger you should not set the property rowDrag=true in the Column Definition. Doing that will cause the cell to have two row draggers.
Full Width Row Dragging Copy Link
It is possible to drag Full Width Rows by registering a Custom Row Dragger.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GetRowHeight,
GridApi,
GridOptions,
GridReadyEvent,
ICellRendererParams,
IsFullWidthRow,
IsFullWidthRowParams,
ModuleRegistry,
RowDragModule,
RowHeightParams,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import FullWidthCellRenderer from "./fullWidthCellRendererVue";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
RowDragModule,
ClientSideRowModelModule,
]);
function countryCellRenderer(params: ICellRendererParams) {
if (!params.fullWidth) {
return params.value;
}
const flag =
'<img border="0" width="15" height="10" src="https://www.ag-grid.com/example-assets/flags/' +
params.data.code +
'.png">';
return (
'<span style="cursor: default;">' + flag + " " + params.value + "</span>"
);
}
function isFullWidth(data: any) {
// return true when country is Peru, France or Italy
return ["Peru", "France", "Italy"].indexOf(data.name) >= 0;
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"
:rowDragManaged="true"
:getRowHeight="getRowHeight"
:isFullWidthRow="isFullWidthRow"
:fullWidthCellRenderer="fullWidthCellRenderer"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
FullWidthCellRenderer,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "name", cellRenderer: countryCellRenderer },
{ field: "continent" },
{ field: "language" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
filter: true,
});
const rowData = ref<any[] | null>(getData());
const getRowHeight = ref<GetRowHeight>((params: RowHeightParams) => {
// return 100px height for full width rows
if (isFullWidth(params.data)) {
return 100;
}
});
const isFullWidthRow = ref<IsFullWidthRow>(
(params: IsFullWidthRowParams) => {
return isFullWidth(params.rowNode.data);
},
);
const fullWidthCellRenderer = ref<any>("FullWidthCellRenderer");
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
getRowHeight,
isFullWidthRow,
fullWidthCellRenderer,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.full-width-panel {
/* undo the white-space setting Fresh puts in */
white-space: normal;
height: 100%;
width: 100%;
border: 2px solid grey;
border-style: ridge;
box-sizing: border-box;
padding: 5px;
background-color: #99999944;
}
.full-width-flag {
float: left;
padding: 6px;
}
.full-width-summary {
float: left;
/*margin-left: 10px;*/
margin-right: 10px;
}
.full-width-panel label {
padding-top: 3px;
display: inline-block;
font-size: 12px;
}
.full-width-center {
overflow-y: scroll;
border: 1px solid grey;
padding: 2px;
height: 100%;
box-sizing: border-box;
font-family: cursive;
background-color: #99999944;
}
.full-width-center p {
margin-top: 0px;
}
.full-width-title {
font-size: 20px;
}
export function getData(): any[] {
const rowData = [
{
// these attributes appear in the top level rows of the grid
name: 'Ireland',
continent: 'Europe',
language: 'English',
code: 'ie',
// these are used in the panel
population: 4000000,
},
// and then repeat for all the other countries
{
name: 'Spain',
continent: 'Europe',
language: 'Spanish',
code: 'es',
population: 4000000,
},
{
name: 'United Kingdom',
continent: 'Europe',
language: 'English',
code: 'gb',
population: 4000000,
},
{
name: 'France',
continent: 'Europe',
language: 'French',
code: 'fr',
population: 4000000,
},
{
name: 'Germany',
continent: 'Europe',
language: 'German',
code: 'de',
population: 4000000,
},
{
name: 'Sweden',
continent: 'Europe',
language: 'Swedish',
code: 'se',
population: 4000000,
},
{
name: 'Norway',
continent: 'Europe',
language: 'Norwegian',
code: 'no',
population: 4000000,
},
{
name: 'Italy',
continent: 'Europe',
language: 'Italian',
code: 'it',
population: 4000000,
},
{
name: 'Greece',
continent: 'Europe',
language: 'Greek',
code: 'gr',
population: 4000000,
},
{
name: 'Iceland',
continent: 'Europe',
language: 'Icelandic',
code: 'is',
population: 4000000,
},
{
name: 'Portugal',
continent: 'Europe',
language: 'Portuguese',
code: 'pt',
population: 4000000,
},
{
name: 'Malta',
continent: 'Europe',
language: 'Maltese',
code: 'mt',
population: 4000000,
},
{
name: 'Brazil',
continent: 'South America',
language: 'Portuguese',
code: 'br',
population: 4000000,
},
{
name: 'Argentina',
continent: 'South America',
language: 'Spanish',
code: 'ar',
population: 4000000,
},
{
name: 'Colombia',
continent: 'South America',
language: 'Spanish',
code: 'co',
population: 4000000,
},
{
name: 'Peru',
continent: 'South America',
language: 'Spanish',
code: 'pe',
population: 4000000,
},
{
name: 'Venezuela',
continent: 'South America',
language: 'Spanish',
code: 've',
population: 4000000,
},
{
name: 'Uruguay',
continent: 'South America',
language: 'Spanish',
code: 'uy',
population: 4000000,
},
];
return rowData;
}
export default {
template: `
<div class="full-width-panel" v-on:wheel.stop="">
<div class="full-width-flag">
<img border="0"
:src="imgSrc"/>
</div>
<div class="full-width-summary">
<span class="full-width-title">{{params.node.data.name}}</span>
<br/>
<label>
<b>Population:</b>
{{params.node.data.population}}
</label>
<br/>
<label>
<b>Language:</b>
{{params.node.data.language}}
</label>
<br/>
</div>
<div class="full-width-center">
{{latinText()}}
</div>
</div>
`,
data: function () {
return {
maxValue: 0,
currentValue: 0,
imgSrc: null,
};
},
beforeMount() {
this.maxValue = this.params.maxValue;
this.imgSrc = `https://www.ag-grid.com/example-assets/large-flags/${this.params.node.data.code}.png`;
this.params.registerRowDragger(this.params.eParentOfValue, undefined, this.params.data.name, true);
},
methods: {
latinText() {
return '<p>Sample Text in a Paragraph</p><p>Lorem ipsum dolor sit amet, his mazim necessitatibus te, mea volutpat intellegebat at. Ea nec perpetua liberavisse, et modo rebum persius pri. Velit recteque reprimique quo at. Vis ex persius oporteat, esse voluptatum moderatius te vis. Ex agam suscipit aliquando eum. Mediocrem molestiae id pri, ei cibo facilisis mel. Ne sale nonumy sea. Et vel lorem omittam vulputate. Ne prima impedit percipitur vis, erat summo an pro. Id urbanitas deterruisset cum, at legere oportere has. No saperet lobortis elaboraret qui, alii zril at vix, nulla soluta ornatus per ad. Feugiat consequuntur vis ad, te sit quodsi persequeris, labore perpetua mei ad. Ex sea affert ullamcorper disputationi, sit nisl elit elaboraret te, quodsi doctus verear ut eam. Eu vel malis nominati, per ex melius delenit incorrupte. Partem complectitur sed in. Vix dicta tincidunt ea. Id nec urbanitas voluptaria, pri no nostro disputationi. Falli graeco salutatus pri ea.</p><p>Quo ad omnesque phaedrum principes, tale urbanitas constituam et ius, pericula consequat ad est. Ius tractatos referrentur deterruisset an, odio consequuntur sed ad. Ea molestie adipiscing adversarium eos, tale veniam sea no. Mutat nullam philosophia sed ad. Pri eu dicta consulatu, te mollis quaerendum sea. Ei doming commodo euismod vis. Cu modus aliquip inermis his, eos et eirmod regione delicata, at odio definiebas vis.</p><p>Lorem ipsum dolor sit amet, his mazim necessitatibus te, mea volutpat intellegebat at. Ea nec perpetua liberavisse, et modo rebum persius pri. Velit recteque reprimique quo at. Vis ex persius oporteat, esse voluptatum moderatius te vis. Ex agam suscipit aliquando eum. Mediocrem molestiae id pri, ei cibo facilisis mel. Ne sale nonumy sea. Et vel lorem omittam vulputate. Ne prima impedit percipitur vis, erat summo an pro. Id urbanitas deterruisset cum, at legere oportere has. No saperet lobortis elaboraret qui, alii zril at vix, nulla soluta ornatus per ad. Feugiat consequuntur vis ad, te sit quodsi persequeris, labore perpetua mei ad. Ex sea affert ullamcorper disputationi, sit nisl elit elaboraret te, quodsi doctus verear ut eam. Eu vel malis nominati, per ex melius delenit incorrupte. Partem complectitur sed in. Vix dicta tincidunt ea. Id nec urbanitas voluptaria, pri no nostro disputationi. Falli graeco salutatus pri ea.</p><p>Quo ad omnesque phaedrum principes, tale urbanitas constituam et ius, pericula consequat ad est. Ius tractatos referrentur deterruisset an, odio consequuntur sed ad. Ea molestie adipiscing adversarium eos, tale veniam sea no. Mutat nullam philosophia sed ad. Pri eu dicta consulatu, te mollis quaerendum sea. Ei doming commodo euismod vis. Cu modus aliquip inermis his, eos et eirmod regione delicata, at odio definiebas vis.</p>';
},
},
};
In the example above, only the full width rows are draggable.
Row Dragger with Custom Start Drag Pixels Copy Link
By default, the drag event only starts after the Row Drag Element has been dragged by 4px, but sometimes it might be useful to start the drag with a different drag threshold. For example, start dragging as soon as the mousedown event happens (dragged by 0px). For that reason, the registerRowDragger takes a second parameter to specify the number of pixels that will start the drag event.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
CellStyleModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragCancelEvent,
RowDragEndEvent,
RowDragEnterEvent,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomCellRenderer from "./customCellRendererVue";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
CellStyleModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowDragManaged="true"
:rowData="rowData"
@row-drag-enter="onRowDragEnter"
@row-drag-end="onRowDragEnd"
@row-drag-cancel="onRowDragCancel"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomCellRenderer,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "athlete",
cellClass: "custom-athlete-cell",
cellRenderer: "CustomCellRenderer",
},
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = ref<ColDef>({
width: 170,
filter: true,
});
const rowData = ref<IOlympicData[]>(null);
function onRowDragEnter(e: RowDragEnterEvent) {
console.log("onRowDragEnter: node", e.node.id);
}
function onRowDragEnd(e: RowDragEndEvent) {
console.log("onRowDragEnd: node", e.node.id);
}
function onRowDragCancel(e: RowDragCancelEvent) {
console.log("onRowDragCancel: node", e.node.id);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
onRowDragEnter,
onRowDragEnd,
onRowDragCancel,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.ag-ltr .ag-has-focus .ag-cell.custom-athlete-cell.ag-cell-focus:not(.ag-cell-range-selected) {
border: 1px solid #ff7b7b;
}
.ag-cell.custom-athlete-cell {
padding-left: 0;
padding-right: 0;
}
.ag-cell.custom-athlete-cell > div {
height: 100%;
}
.my-custom-cell-renderer {
display: flex;
font-size: 0.7rem;
background-color: #4180d6;
color: white;
padding: 0.25rem;
align-items: center;
justify-content: space-between;
box-sizing: border-box;
height: 100%;
}
.my-custom-cell-renderer > * {
line-height: normal;
}
.my-custom-cell-renderer i {
visibility: hidden;
cursor: move;
color: orange;
}
.my-custom-cell-renderer:hover i {
visibility: visible;
}
.my-custom-cell-renderer .athlete-info {
display: flex;
flex-direction: column;
width: 85px;
max-width: 85px;
}
.my-custom-cell-renderer .athlete-info > span {
overflow: hidden;
text-overflow: ellipsis;
}
export default {
template: `
<div class="my-custom-cell-renderer">
<div class="athlete-info">
<span>{{ athlete }}</span>
<span>{{ country }}</span>
</div>
<span>{{ year }}</span>
<i class="fas fa-arrows-alt-v" ref="myRef"></i>
</div>`,
data: function () {
return {
athlete: '',
country: '',
year: '',
};
},
beforeMount() {
this.athlete = this.params.data.athlete;
this.country = this.params.data.country;
this.year = this.params.data.year;
},
mounted() {
this.params.registerRowDragger(this.$refs.myRef, 0);
},
};
In the example above, the drag event starts as soon as mousedown is fired.
Custom Drag and Drop Image Copy Link
The drag and drop image can be customised via the grid properties dragAndDropImageComponent and dragAndDropImageComponentParams.
Any valid Vue component can be a drag and drop image component, however it must implement the IDragAndDropImage interface:
IDragAndDropImage Copy Link
interface IDragAndDropImage {
setIcon(iconName: string | null, shake: boolean): void;
setLabel(label: string): void;
} Custom Params Copy Link
On top of the parameters provided by the grid, you can also provide your own parameters. This is useful if you want to allow configuring the component. For example, you might have parts of the grid that you want to highlight with a different colour.
colDef = {
dragAndDropImageComponent: 'MyDragAndDropImageComponent',
dragAndDropImageComponentParams : {
accentColour: 'SlateGray'
}
}import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
RowDragModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import CustomDragAndDropImage from "./customDragAndDropImageVue";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextFilterModule,
NumberFilterModule,
RowDragModule,
ClientSideRowModelModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowDragManaged="true"
:dragAndDropImageComponent="dragAndDropImageComponent"
:dragAndDropImageComponentParams="dragAndDropImageComponentParams"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
CustomDragAndDropImage,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", rowDrag: true },
{ field: "country" },
{ field: "year", width: 100 },
{ field: "date" },
{ field: "sport" },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
]);
const defaultColDef = ref<ColDef>({
width: 170,
filter: true,
});
const dragAndDropImageComponent = ref("CustomDragAndDropImage");
const dragAndDropImageComponentParams = ref({
accentColour: "SlateGray",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
dragAndDropImageComponent,
dragAndDropImageComponentParams,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.my-custom-drag-and-drop-cover {
padding: 2rem;
color: white;
cursor: move;
display: flex;
align-items: center;
gap: 0.5rem;
border-radius: 0.5rem;
}
export default {
template: `
<div class="my-custom-drag-and-drop-cover" ref="eImage">
<i class="fas fa-2x" ref="eIcon"></i>
<div ref="eLabel"></div>
</div>
`,
mounted() {
this.$refs.eImage.style.setProperty('background-color', this.params.accentColour);
},
methods: {
setLabel(label) {
this.$refs.eLabel.innerHTML = label;
},
setIcon(icon) {
const { dragSource, api } = this.params;
const { eIcon } = this.$refs;
if (!icon) {
icon = dragSource.getDefaultIconName ? dragSource.getDefaultIconName() : 'notAllowed';
}
if (icon === 'hide' && api.getGridOption('suppressDragLeaveHidesColumns')) {
return;
}
eIcon.classList.toggle('fa-hand-point-left', icon === 'left');
eIcon.classList.toggle('fa-hand-point-right', icon === 'right');
eIcon.classList.toggle('fa-mask', icon === 'hide');
eIcon.classList.toggle('fa-ban', icon === 'notAllowed');
eIcon.classList.toggle('fa-thumbtack', icon === 'pinned');
eIcon.classList.toggle('fa-walking', icon === 'move');
},
},
};